<template>
  <div class="user-personal-info">
    <div class="header">
      <JAvatar
        size="xxl"
        class="user-avatar"
      >
        <BaseImg
          :src="user.avatar"
          alt="User image"
          class="user-image"
        />
      </JAvatar>
      <div class="details-info">
        <JText
          tag="h3"
          color="text"
          type="text-2"
          weight="bold"
          class="name"
        >
          {{ user.name }}
        </JText>
        <JText
          color="third-text"
          weight="normal"
          type="text-4"
        >
          Был(-а) в сети: 10.07
        </JText>
      </div>
    </div>
    <div class="actions-list">
      <MakeCallBtn
        audio
        video
        :call-target="user"
        :chat-id="user.id"
      >
        <template #default="{ makeCall, disable }">
          <JActionIcon
            size="s"
            :disable="disable"
            class="call-with-camera action"
            @keydown.space="makeCall"
            @keydown.enter="makeCall"
            @click="makeCall"
          >
            <JIcon
              icon="camera"
              size="20px"
            />
          </JActionIcon>
        </template>
      </MakeCallBtn>

      <MakeCallBtn
        audio
        :call-target="user"
        :chat-id="user.id"
      >
        <template #default="{ makeCall, disable }">
          <JActionIcon
            size="s"
            :disable="disable"
            class="call action"
            @keydown.space="makeCall"
            @keydown.enter="makeCall"
            @click="makeCall"
          >
            <JIcon
              icon="phone"
              size="20px"
            />
          </JActionIcon>
        </template>
      </MakeCallBtn>

      <ConversationDetailsLink
        :chat-id="user.id"
        :alt="`Open ${user.name} chat`"
        class="action"
        @click="menuModel = false"
      />

      <OpenChatInNewLayer
        v-slot="chatNewLayerSlotProps"
        :chat-id="user.id"
        @click="menuModel = false"
      >
        <JActionIcon
          v-bind="chatNewLayerSlotProps"
          size="s"
          alt="Open in new layer"
          class="action"
        >
          <JIcon
            icon="newLayer"
            size="20px"
          />
        </JActionIcon>
      </OpenChatInNewLayer>
    </div>
    <JDivider
      height="0.5px"
      margin-top="10px"
      margin-bottom="10px"
    />
    <div class="contacts">
      <JText
        weight="bold"
        color="text"
        type="text-4"
        class="contacts-label"
      >
        {{ $t('contacts') }}
      </JText>
      <JList class="">
        <JListItem
          size="m"
          tag="a"
          :href="'mailto:' + user.email"
        >
          <JIcon
            icon="email"
            size="24px"
            container-size
          />
          <JText
            type="text-4"
            color="primary"
            weight="bold"
            class="ml-2"
          >
            {{ user.email }}
          </JText>
        </JListItem>
      </JList>
    </div>
  </div>
</template>

<script setup lang="ts">
import { PropType, ref } from 'vue';
import {
  JAvatar,
  JText,
  JDivider,
  JList,
  JIcon,
  JListItem,
  JActionIcon,
} from '@new-jira-clone/ui/src/components';
import { OpenChatInNewLayer } from '@/features/open-chat-in-new-layer';
import { MakeCallBtn } from '@/features/make-call';
import { ConversationDetailsLink } from '@/entities/Conversation';
import { IUser } from '@/shared';

defineProps({
  user: {
    type: Object as PropType<IUser>,
    required: true,
  },
});

const menuModel = ref(false);
</script>

<style scoped lang="scss">
.user-personal-info {
  padding-top: 16px;
  padding-bottom: 8px;
  min-width: 330px;

  .header {
    display: flex;
    margin-bottom: 10px;
    padding: 0 18px;
  }

  .details-info {
    display: flex;
    flex-direction: column;
    justify-content: center;
    margin-left: 20px;
    margin-bottom: 6px;
  }

  .name {
    white-space: nowrap;
    margin-bottom: 4px;
  }

  .actions-list {
    display: flex;
    padding: 0 18px;
  }

  .contacts-label {
    padding: 0 18px;
  }

  .action {
    &:nth-child(n + 2) {
      margin-left: 4px;
    }
  }

  .copy {
    margin-left: auto;
  }
}

.call-with-camera,
.call {
  color: rgb(var(--j-primary-color));
}
</style>
